searchNodes=[{"doc":"Public API Example workflow: # The model will be stored under this path { :ok , model } = Markov . load ( &quot;./model_path&quot; , sanitize_tokens : true , store_log : [ :train ] ) # train using four strings :ok = Markov . train ( model , &quot;hello, world!&quot; ) :ok = Markov . train ( model , &quot;example string number two&quot; ) :ok = Markov . train ( model , &quot;hello, Elixir!&quot; ) :ok = Markov . train ( model , &quot;fourth string&quot; ) # generate text { :ok , text } = Markov . generate_text ( model ) IO . puts ( text ) # commit all changes and unload Markov . unload ( model ) # these will return errors because the model is unloaded # Markov.generate_text(model) # Markov.train(model, &quot;hello, world!&quot;) # load the model again { :ok , model } = Markov . load ( &quot;./model_path&quot; ) # enable probability shifting and generate text :ok = Markov . configure ( model , shift_probabilities : true ) { :ok , text } = Markov . generate_text ( model ) IO . puts ( text ) # print uninteresting stats model |&gt; Markov . dump_partition ( 0 ) |&gt; IO . inspect model |&gt; Markov . read_log |&gt; IO . inspect # this will also write our new just-set option Markov . unload ( model )","ref":"Markov.html","title":"Markov","type":"module"},{"doc":"Reconfigures a loaded model. See model_option/0 for a thorough description of the options","ref":"Markov.html#configure/2","title":"Markov.configure/2","type":"function"},{"doc":"Generates a string. Will raise an exception if the model was trained on non-textual tokens at least once iex&gt; Markov . generate_text ( model ) { :ok , &quot;hello world&quot; } See type tag_query/0 for more info about tags","ref":"Markov.html#generate_text/2","title":"Markov.generate_text/2","type":"function"},{"doc":"Generates a list of tokens iex&gt; Markov . generate_tokens ( model ) { :ok , [ &quot;hello&quot; , &quot;world&quot; ] } See type tag_query/0 for more info about tag_query","ref":"Markov.html#generate_tokens/2","title":"Markov.generate_tokens/2","type":"function"},{"doc":"Gets the configuration of a loaded model","ref":"Markov.html#get_config/1","title":"Markov.get_config/1","type":"function"},{"doc":"Loads an existing model under path path . If none is found, a new model with the specified options will be created and loaded, and if that fails, an error will be returned.","ref":"Markov.html#load/2","title":"Markov.load/2","type":"function"},{"doc":"Reads the log file and returns a list of entries in chronological order iex&gt; Markov . read_log ( model ) { :ok , [ % Markov.Operation { date_time : ~U[2022-10-02 16:59:51.844Z] , type : :start , arg : nil } , % Markov.Operation { date_time : ~U[2022-10-02 16:59:56.705Z] , type : :train , arg : [ &quot;hello&quot; , &quot;world&quot; ] } ] }","ref":"Markov.html#read_log/1","title":"Markov.read_log/1","type":"function"},{"doc":"Trains model using text or a list of tokens. :ok = Markov . train ( model , &quot;Hello, world!&quot; ) :ok = Markov . train ( model , &quot;this is a string that&#39;s broken down into tokens behind the scenes&quot; ) :ok = Markov . train ( model , [ :this , &quot;is&quot; , &#39;a token&#39; , :list , &quot;where&quot; , { :each_element , :is , { :taken , :as_is } } , :and , :can_be , :erlang . make_ref ( ) , &quot;&lt;-- any term&quot; ] ) See tag_query/0 for more info about tags","ref":"Markov.html#train/3","title":"Markov.train/3","type":"function"},{"doc":"Unloads a loaded model","ref":"Markov.html#unload/1","title":"Markov.unload/1","type":"function"},{"doc":"","ref":"Markov.html#t:log_entry_type/0","title":"Markov.log_entry_type/0","type":"type"},{"doc":"Model options that could be set during creation in a call to load/3 or with configure/2 : store_log : determines what data to put in the operation log, all of them by default: :start - model is loaded :end - model is unloaded :train : training requests :gen : generation results shift_probabilities : gives less popular generation paths more chance to get used, which makes the output more original but may produce nonsense; false by default sanitize_tokens : ignores letter case and punctuation when switching states, but still keeps the output as-is; false by default, can't be changed once the model is created order : order of the chain, i.e. how many previous tokens the next one is based on; 2 by default, can never be changed once the model is created","ref":"Markov.html#t:model_option/0","title":"Markov.model_option/0","type":"type"},{"doc":"","ref":"Markov.html#t:model_reference/0","title":"Markov.model_reference/0","type":"opaque"},{"doc":"If data was tagged when training, you can use tag queries to alter the probabilities of certain generation paths Examples: # training iex&gt; Markov . train ( model , &quot;hello earth&quot; , [ { :action , :saying_hello } , # &lt;- terms of any type can function as tags { :subject_type , :planet } , { :subject , &quot;earth&quot; } , :lowercase ] ) :ok iex&gt; Markov . train ( model , &quot;Hello Elixir&quot; , [ { :action , :saying_hello } , { :subject_type , :programming_language } , { :subject , &quot;Elixir&quot; } , :uppercase ] ) :ok # simple generation - both paths have equal probabilities iex&gt; Markov . generate_text ( model ) { :ok , &quot;hello earth&quot; } iex&gt; Markov . generate_text ( model ) { :ok , &quot;hello Elixir&quot; } # All generation paths have a score of 1 by default. Here we&#39;re telling # Markov to add 1 point to paths tagged with `:uppercase`; # &quot;hello Elixir&quot; now has a score of 2 and &quot;hello earth&quot; has a score of 1. # Thus, &quot;hello Elixir&quot; has a probability of 2/3, and &quot;hello earth&quot; has # that of 1/3 iex&gt; Markov . generate_text ( model , %{ uppercase : 1 } ) { :ok , &quot;hello Elixir&quot; } iex&gt; Markov . generate_text ( model , %{ uppercase : 1 } ) { :ok , &quot;hello Elixir&quot; } iex&gt; Markov . generate_text ( model , %{ uppercase : 1 } ) { :ok , &quot;hello earth&quot; }","ref":"Markov.html#t:tag_query/0","title":"Markov.tag_query/0","type":"type"},{"doc":"Markov OTP app","ref":"Markov.App.html","title":"Markov.App","type":"module"},{"doc":"Loads the dictionary for prompt generation into a ets table","ref":"Markov.DictionaryHolder.html","title":"Markov.DictionaryHolder","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Markov.DictionaryHolder.html#child_spec/1","title":"Markov.DictionaryHolder.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Markov.DictionaryHolder.html#init/1","title":"Markov.DictionaryHolder.init/1","type":"function"},{"doc":"","ref":"Markov.DictionaryHolder.html#start_link/1","title":"Markov.DictionaryHolder.start_link/1","type":"function"},{"doc":"","ref":"Markov.ListUtil.html","title":"Markov.ListUtil","type":"module"},{"doc":"Splits the list into size -sized lists of consecutive elements Example iex&gt; Markov.ListUtil . overlapping_stride ( [ :a , :b , :c , :d , :e , :f , :g ] , 3 ) [ [ :a , :b , :c ] , [ :b , :c , :d ] , [ :c , :d , :e ] , [ :d , :e , :f ] , [ :e , :f , :g ] ] iex&gt; Markov.ListUtil . overlapping_stride ( [ :a , :b , :c , :d , :e , :f , :g ] , 2 ) [ [ :a , :b ] , [ :b , :c ] , [ :c , :d ] , [ :d , :e ] , [ :e , :f ] , [ :f , :g ] ]","ref":"Markov.ListUtil.html#overlapping_stride/2","title":"Markov.ListUtil.overlapping_stride/2","type":"function"},{"doc":"Performs training, generation and probability shifting. Supposed to only ever be used by Markov.ModelServer s.","ref":"Markov.ModelActions.html","title":"Markov.ModelActions","type":"module"},{"doc":"Adjust the probabilities of a batch of connections","ref":"Markov.ModelActions.html#adjust_batch_probs/1","title":"Markov.ModelActions.adjust_batch_probs/1","type":"function"},{"doc":"Adjusts the probability of one connection","ref":"Markov.ModelActions.html#adjust_one_prob/1","title":"Markov.ModelActions.adjust_one_prob/1","type":"function"},{"doc":"","ref":"Markov.ModelActions.html#generate/2","title":"Markov.ModelActions.generate/2","type":"function"},{"doc":"","ref":"Markov.ModelActions.html#next_state/3","title":"Markov.ModelActions.next_state/3","type":"function"},{"doc":"processes tag scores","ref":"Markov.ModelActions.html#process_scores/2","title":"Markov.ModelActions.process_scores/2","type":"function"},{"doc":"","ref":"Markov.ModelActions.html#train/3","title":"Markov.ModelActions.train/3","type":"function"},{"doc":"","ref":"Markov.ModelActions.html#walk_chain/5","title":"Markov.ModelActions.walk_chain/5","type":"function"},{"doc":"GenServer in charge of one model","ref":"Markov.ModelServer.html","title":"Markov.ModelServer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Markov.ModelServer.html#child_spec/1","title":"Markov.ModelServer.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Markov.ModelServer.html#init/1","title":"Markov.ModelServer.init/1","type":"function"},{"doc":"","ref":"Markov.ModelServer.html#log_entry_mapping/0","title":"Markov.ModelServer.log_entry_mapping/0","type":"function"},{"doc":"","ref":"Markov.ModelServer.html#rev_log_entry_map/0","title":"Markov.ModelServer.rev_log_entry_map/0","type":"function"},{"doc":"","ref":"Markov.ModelServer.html#start/1","title":"Markov.ModelServer.start/1","type":"function"},{"doc":"","ref":"Markov.ModelServer.html#start_link/1","title":"Markov.ModelServer.start_link/1","type":"function"},{"doc":"","ref":"Markov.ModelServer.html#t:start_options/0","title":"Markov.ModelServer.start_options/0","type":"type"},{"doc":"","ref":"Markov.ModelServer.State.html","title":"Markov.ModelServer.State","type":"module"},{"doc":"","ref":"Markov.ModelServer.State.html#t:t/0","title":"Markov.ModelServer.State.t/0","type":"type"},{"doc":"","ref":"Markov.Operation.html","title":"Markov.Operation","type":"module"},{"doc":"Thin wrapper around Markov to make the chain respond to prompts assuming it's been trained on the appropriate data","ref":"Markov.Prompt.html","title":"Markov.Prompt","type":"module"},{"doc":"Generates the text from a prompt","ref":"Markov.Prompt.html#generate_prompted/3","title":"Markov.Prompt.generate_prompted/3","type":"function"},{"doc":"Assuming your application receives a stream of strings, call this function instead of Markov.train/3 with the current and last string","ref":"Markov.Prompt.html#train/4","title":"Markov.Prompt.train/4","type":"function"},{"doc":"Trains the model on a list of consecutive strings","ref":"Markov.Prompt.html#train_on_list/2","title":"Markov.Prompt.train_on_list/2","type":"function"},{"doc":"Main supervisor","ref":"Markov.Sup.html","title":"Markov.Sup","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Markov.Sup.html#child_spec/1","title":"Markov.Sup.child_spec/1","type":"function"},{"doc":"","ref":"Markov.Sup.html#start_link/1","title":"Markov.Sup.start_link/1","type":"function"},{"doc":"","ref":"Markov.Sup.html#stop/0","title":"Markov.Sup.stop/0","type":"function"},{"doc":"","ref":"Markov.TextUtil.html","title":"Markov.TextUtil","type":"module"},{"doc":"Strips textual tokens of preceding and trailing non-word characters and downcases them iex&gt; Markov.TextUtil . sanitize_token ( :atom ) :atom iex&gt; Markov.TextUtil . sanitize_token ( &quot;test&quot; ) &quot;test&quot; iex&gt; Markov.TextUtil . sanitize_token ( &quot; !!!???/// tEsT &gt;&gt;&gt;&quot; ) &quot;test&quot;","ref":"Markov.TextUtil.html#sanitize_token/1","title":"Markov.TextUtil.sanitize_token/1","type":"function"},{"doc":"Text generation library based on nth-order Markov chains","ref":"readme.html","title":"Markov","type":"extras"},{"doc":"Token sanitation (optional): ignores letter case and punctuation when switching states, but still keeps the output as-is Operation history (optional): recalls the operations it was instructed to perform, incl. past training data Probability shifting (optional): gives less frequent generation paths more chance to get used, which makes the output more original but may produce nonsense Tagging (optional): you can tag your source data and alter the probabilities of tagged generation paths according to your rules Prompted generation (optional) grants your model the ability to answer questions given to it provided that the training data consists mostly of Q&amp;A pairs Managed disk storage so you don't have to worry about storing and loading the models Transparent fragmentation reduces RAM usage and loading times with huge models","ref":"readme.html#features","title":"Markov - Features","type":"extras"},{"doc":"In mix.exs : defp deps do [ { :markov , &quot;~&gt; 4.0&quot; } ] end Unlike Markov 1.x, this version has very strong opinions on how you should create and persist your models (that also differs from 2.x and 3.x). Example workflow (click here for full docs): # The model will be stored under this path { :ok , model } = Markov . load ( &quot;./model_path&quot; , sanitize_tokens : true , store_log : [ :train ] ) # train using four strings :ok = Markov . train ( model , &quot;hello, world!&quot; ) :ok = Markov . train ( model , &quot;example string number two&quot; ) :ok = Markov . train ( model , &quot;hello, Elixir!&quot; ) :ok = Markov . train ( model , &quot;fourth string&quot; ) # generate text { :ok , text } = Markov . generate_text ( model ) IO . puts ( text ) # commit all changes and unload Markov . unload ( model ) # these will return errors because the model is unloaded # Markov.generate_text(model) # Markov.train(model, &quot;hello, world!&quot;) # load the model again { :ok , model } = Markov . load ( &quot;./model_path&quot; ) # enable probability shifting and generate text :ok = Markov . configure ( model , shift_probabilities : true ) { :ok , text } = Markov . generate_text ( model ) IO . puts ( text ) # print uninteresting stats model |&gt; Markov . dump_partition ( 0 ) |&gt; IO . inspect model |&gt; Markov . read_log |&gt; IO . inspect # this will also write our new just-set option Markov . unload ( model )","ref":"readme.html#usage","title":"Markov - Usage","type":"extras"},{"doc":"The English dictionary in a CSV format","ref":"readme.html#credits","title":"Markov - Credits","type":"extras"}]